<script lang="ts">
  import { flip } from "svelte/animate";
  import { slide } from "svelte/transition";
  import CurrencyCard from "./components/CurrencyCard.svelte";
  import CurrencyDeck from "./components/CurrencyDeck.svelte";
  import Player from "./components/Player.svelte";
  import PropertyCard from "./components/PropertyCard.svelte";
  import PropertyDeck from "./components/PropertyDeck.svelte";
  import SaleCards from "./components/SaleCards.svelte";
  import Summary from "./components/Summary.svelte";
  import { sortedByValue, sortedCompletedSalesByPropertyValue } from "./utils";

  export let playerId: PlayerId | null;
  // export let settings: Settings;
  export let state: GameState;

  let user: globalThis.Player | null;
  $: user = state.players.find((p) => p.id === playerId) ?? null;
</script>

<div class="center">
  {#if state.phase.name === "buying" || state.phase.name === "buyingComplete"}
    <div class="deck">
      <PropertyDeck deck={state.phase.propertyDeck} />
    </div>
  {/if}

  {#if state.phase.name === "buying"}
    <div
      class="buying-properties card-grid-{state.players.length}-players"
      transition:slide
    >
      {#each sortedByValue(state.phase.properties) as card (card)}
        <div animate:flip={{ duration: 500 }}>
          <PropertyCard {card} />
        </div>
      {/each}
    </div>
  {/if}

  {#if state.phase.name === "selling" || state.phase.name === "sellingComplete"}
    <div class="deck">
      <CurrencyDeck deck={state.phase.currencyDeck} />
    </div>
  {/if}

  {#if state.phase.name === "selling"}
    <div
      class="offers card-grid-{state.players.length}-players"
      transition:slide
    >
      {#each sortedByValue(state.phase.currencies) as card}
        <div>
          <CurrencyCard {card} />
        </div>
      {/each}
    </div>
  {:else if state.phase.name === "sellingComplete"}
    <div
      class="completed-sales card-grid-{state.players.length}-players"
      transition:slide
    >
      {#each sortedCompletedSalesByPropertyValue(Object.entries(state.phase.saleResult)) as [playerId, [property, currency]] (playerId)}
        <div>
          <SaleCards {currency} {property} />
          <div class="completed-sale-player border shadow">
            <gs6-user userid={playerId} />
          </div>
        </div>
      {/each}
    </div>
  {/if}
</div>

{#each state.players as player (player.id)}
  <Player {state} {player} {user} on:action />
{/each}

{#if state.phase.name === "gameComplete"}
  <div class="center panel border shadow">
    <Summary players={state.players} />
  </div>
{/if}

<style>
  @font-face {
    font-family: "Delius";
    font-style: normal;
    font-weight: 400;
    font-display: swap;
    src: url(./assets/delius.woff2) format("woff2");
    unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA,
      U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212,
      U+2215, U+FEFF, U+FFFD;
  }

  .center {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    display: flex;
    flex-direction: column;
    align-items: center;
  }

  .deck {
    margin-bottom: 1rem;
  }

  .buying-properties {
    display: flex;
  }
  .buying-properties > * {
    margin: 0.25em;
  }
  .offers {
    display: flex;
  }
  .offers > * {
    margin: 0.25em;
  }

  .completed-sales {
    display: flex;
  }
  .completed-sales > * {
    position: relative;
    margin: 0.25em;
  }

  .completed-sale-player {
    border-radius: 0.5em;
    padding: 0.5em;
    background: white;
    font-size: 0.8em;
    position: absolute;
    left: 50%;
    bottom: 0;
    transform: translate(-50%, -0.5em);
  }

  .card-grid-5-players {
    display: flex;
    width: 20rem;
    flex-wrap: wrap;
    justify-content: center;
  }
  .card-grid-6-players {
    margin-bottom: 6rem;
  }
</style>
